<template>
  <div class="col content mh-auto w-100 flex-1">

    <h1>Register to {{ VUE_APP_NAME }}</h1>

    <Error :error.sync="error" round class="mb-5"/>

    <template v-if="!loading">
      <form class="col w-100 w-md-75 mh-auto flex-ai-center ph-3"
        @submit.prevent="doRegister">
        <div class="input-group w-100">
          <input type="email" v-model="register.email" placeholder>
          <span>Email</span>
        </div>
        <div class="input-group w-100">
          <input type="text" v-model="register.username" placeholder>
          <span>Username</span>
        </div>
        <div class="input-group w-100">
          <input type="password" v-model="register.password" placeholder
            ref="pass">
          <span>Password</span>
        </div>
        <div class="input-group w-100">
          <input type="text" v-model="register.name.first" placeholder>
          <span>First Name</span>
        </div>
        <div class="input-group w-100">
          <input type="text" v-model="register.name.last" placeholder>
          <span>Last Name</span>
        </div>
        <button class="primary w-50 mt-3">Sign Up</button>
      </form>

      <div v-if="canOAuth" class="row flex-wrap mh-auto mt-3 flex-jc-center">
        <button class="flex-noshrink" @click="signInIntra">
          Sign up with Marvin
        </button>
      </div>
    </template>
    <div v-else class="col flex-1">
      <v-icon name="circle-notch" spin scale="2" class="m-auto"/>
    </div>
  </div>
</template>

<script>
import axios from 'axios';
import _ from '@raggesilver/hidash';
// import Loader from '@/components/Loader.vue';

export default {
  data: () => ({
    register: {
      email: null,
      username: null,
      password: null,
      name: {
        first: null,
        last: null,
      },
    },

    canOAuth: true,
    loading: false,

    ...process.env,
    error: null,
  }),
  components: {
  },
  methods: {
    signInIntra () {
      let a = new URL('https://api.intra.42.fr/oauth/authorize');
      a.searchParams.append('client_id', process.env.VUE_APP_INTRA_CLIENT_ID);
      a.searchParams.append('scope', 'public');
      a.searchParams.append('redirect_uri', 'http://localhost:8080/register_42_callback');
      a.searchParams.append('state', '2b16f8b42f3ea4811a11b3f2d10df58e');
      a.searchParams.append('response_type', 'code');
      window.location = a.toString();
    },
    signInIntraCb (code) {
      this.loading = true;
      this.canOAuth = false;
      axios.get(`/api/auth/intra_auth/${code}`)
        .then(({ data }) => {
          this.$store.dispatch('login', data);
          this.$router.push('/').catch(() => {});
        })
        .catch((err) => {
          // 442 is the code we use to identify a user who is not yet registered
          if (err.response && err.response.status === 442) {
            this.register.email = err.response.data.user.email;
            this.register.name = err.response.data.user.name;
            this.register.username = err.response.data.user.username || null;
            setTimeout(() => this.$refs.pass.focus(), 100);
          }
          else {
            console.log(err);
          }
        })
        .finally(() => (this.loading = false));
    },
    async doRegister () {
      let r = /^\S+$/;
      let fields = [
        'email', 'password', 'username', 'name.first', 'name.last',
      ];

      this.error = '';
      for (const f of fields) {
        if (!r.test(_.get(this.register, f) || '')) {
          return (this.error = 'Please fill in all the fields');
        }
      }

      try {
        let { data } = await axios.post('/api/auth/register', {
          ...this.register,
        });

        console.log(data);
        this.$store.dispatch('login', data);
        this.$router.push('/').catch(() => {});
      }
      catch (e) {
        if (_.get(e, 'response.data.error')) {
          this.error = e.response.data.error;
        }
      }
    },
  },
  mounted () {
    if (this.$route.query.intra_code) {
      let q = { ...this.$route.query };
      const code = q.intra_code;

      delete q.intra_code;
      this.$router.replace({ query: q });
      this.signInIntraCb(code);
    }
  },
};
</script>

<style scoped>
.content {
  max-width: 600px;
}
</style>
